#include "testApp.h"


// comparison routine for sort...
bool comparisonFunction(  particle * a, particle * b ) { 
	return a->pos.x < b->pos.x; 
}            
//--------------------------------------------------------------
void testApp::setup(){	
	
	ofBackground(0,0,0);
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	
	for (int i = 0; i < 500; i++){
		particle myParticle;
		myParticle.setInitialCondition(ofRandom(500,550),ofRandom(500,550),0,0);
		particles.push_back(myParticle);
	}
	
	
	particles[0].bFixed = true;
	particles[0].setInitialCondition(0,0,0,0);

	
	for (int i = 1; i < particles.size(); i++){
		
		spring mySpring;
		mySpring.distance		= 20;
		mySpring.springiness	= 0.1f;
		if (i%10==0) {
			mySpring.particleA = & (particles[i]);
			particles[i].bFixed = true;
			particles[i].setInitialCondition(i*2,0,0,0);
			
		//	particles[i-1].bFixed = true;
			particles[i-1].setInitialCondition((i-5)*2,ofGetHeight(),0,0);


		} else {
			mySpring.particleA = & (particles[i-1  ]);

		}
		mySpring.particleB = & (particles[i]);
		springs.push_back(mySpring);
	}
	
	
	
	//objects
	//declare objects
	for (int i = 0; i<1; i++) {
		particle * p = new particle();
		
		ofPoint temp;
		temp.set(0, ofRandom(0, ofGetHeight()));			
		p->setInitialCondition(temp.x,temp.y,0,0);
		movingParticles.push_back(p);		
	}
	
	
	
	
	VF.setupField(60,40,ofGetWidth(), ofGetHeight());
	//VF.randomizeField(10.0);
	
		
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	sort( movingParticles.begin(), movingParticles.end(), comparisonFunction );               // sort them!

	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		ofxVec2f frc;
		frc = VF.getForceFromPos(particles[i].pos.x, particles[i].pos.y);
		particles[i].addForce(frc.x, frc.y);
		particles[i].addForce(ofRandom(-0.3, 0.3), 1.3);

	}
	
	for (int i = 0; i < particles.size(); i++){
		for (int ii =0; ii<movingParticles.size(); ii++) {
			particles[i].addRepulsionForce(*movingParticles[ii], 100, 3.5f);
			
			//myParticles[i]->addAttractionForce(*movingParticles[ii], 200, 2.0f);
		}
		
		
		
		particles[i].addRepulsionForce(mouseX, mouseY, 200, 3.0f);
		
		for (int j = 0; j < i; j++){
			particles[i].addRepulsionForce(particles[j], 100, 0.03);
		}
	}
	
	for (int i = 0; i < springs.size(); i++){
		springs[i].update();
	}
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].addDampingForce();
		particles[i].update();
	}
	
	
	//OBJECTS
	
	for (int i = 0; i < movingParticles.size(); i++){
        movingParticles[i]->resetForce();
		ofxVec2f frc;
		frc = VF.getForceFromPos(movingParticles[i]->pos.x, movingParticles[i]->pos.y);
		movingParticles[i]->addForce(frc.x, frc.y);
    }
	
	for (int i = 0; i < movingParticles.size(); i++){
		for (int j = i-1; j >= 0; j--){
			if ( fabs(movingParticles[j]->pos.x - movingParticles[i]->pos.x) >  10) break;
			
			for (int ii =0; ii<particles.size(); ii++) {
				movingParticles[i]->addRepulsionForce(particles[ii], 300, 3.0f);

				
				//myParticles[i]->addAttractionForce(*movingParticles[ii], 200, 2.0f);
			}
			movingParticles[i]->addRepulsionForce( *movingParticles[j],100,0.5f);
			movingParticles[i]->addAttractionForce( *movingParticles[j],200,0.03f);
			
		}
    }
	
	
    for (int i = 0; i < movingParticles.size(); i++){
		movingParticles[i]->pos.x++;
		movingParticles[i]->pos.y=movingParticles[i]->pos.y+2*cos(ofGetElapsedTimef()) ;		
		//movingParticles[i]->addRepulsionForce(movingParticles[i]->pos.x, movingParticles[i]->pos.x, 100, 1.0f);			
		movingParticles[i]->invertWalls();
		
		movingParticles[i]->addAttractionForce( mouseX,mouseY,100,1.7);
		
		
		
		movingParticles[i]->addDampingForce();
		
        movingParticles[i]->update();
	}
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	
	//VF.draw();

	ofSetColor(255,255,255);
	
	for (int i = 0; i < particles.size(); i++){
	//	particles[i].draw();
	}
	
	

	for (int i = 0; i < springs.size(); i++){

		springs[i].draw();
	}
	
	for (int i = 0; i < movingParticles.size(); i++){
		movingParticles[i]->draw();
	//	VF.addOutwardCircle(movingParticles[i]->pos.x, movingParticles[i]->pos.y, 100, 0.2f);
	//	VF.addClockwiseCircle(movingParticles[i]->pos.x, movingParticles[i]->pos.y, 100, 0.2f);
		
		
	}
	

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
	
	switch (key){
			
		case ' ':
			// reposition everything: 
			for (int i = 0; i < particles.size(); i++){
				particles[i].setInitialCondition(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()),0,0);
			}
			break;
	}
	
	
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	//VF.addClockwiseCircle((float)x, (float)y, 100, 0.3f);
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
	//particles[0].pos.set(mouseX, mouseY);

	VF.addOutwardCircle((float)x, (float)y, 100, 0.3f);

	/*particles.erase(particles.begin());
	particle myParticle;
	myParticle.setInitialCondition(x,y,0,0);
	particles.push_back(myParticle);*/
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
	//particles[0].bFixed = true;
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
	//particles[0].bFixed = false;
}

